// LISTING 19.3. Tworzenie listy custom fieldów, które nie są dodane do screenów

import groovy.json.JsonSlurper;

// 1. Token użytkownika.
def token = "OTUxODQxMjc3ODIwOs8GGxW31/mPWMI9gH0UqLp+OQRq";

// 2. URI endpointa Jira REST API.
def url = "http://172.16.117.141:8080/rest/api/2/customFields";

// 3. Otwarcie połączenia z endpointem.
def connection = url.toURL().openConnection() as HttpURLConnection;

// 4. Dodanie parametrów połączenia.
connection.addRequestProperty("Authorization", "Bearer " + token);
connection.addRequestProperty("X-Atlassian-Token", "no-check");
connection.addRequestProperty("Content-Type", "application/json");
connection.setRequestMethod("GET");
connection.setReadTimeout(5000);
connection.connect();

// 5. Załadowanie wyników do obiektu String.
String jsonString = connection.getInputStream().getText("UTF-8");

// 6. Zamknięcie połączenia.
connection.disconnect();

// 7. Wyszukanie i zwrot listy identyfikatorów custom fieldów niewystępujących w screenach.
// W celu wyświetlenia listy w konsoli należy zmienić słowo kluczowe return na println.

return new JsonSlurper().parseText(jsonString)["values"].findAll() {
    customField -> customField["screensCount"]==0;
}.collect() {
    customField -> customField["id"];
};